package gregapi.block.metatype;

import static gregapi.data.CS.*;
import gregapi.block.IBlockToolable;
import gregapi.data.LH;
import gregapi.data.MT;
import gregapi.data.OP;
import gregapi.data.RM;
import gregapi.oredict.IOreDictListenerEvent;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictMaterial;
import gregapi.render.IIconContainer;
import gregapi.util.OM;
import gregapi.util.ST;
import gregapi.util.UT;

import java.util.List;
import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.util.ForgeDirection;
import net.minecraftforge.event.ForgeEventFactory;

public class BlockStones extends BlockMetaType implements IOreDictListenerEvent, IBlockToolable {
	public static final boolean[] MOSSY = {F,F,T,F,F,T,F,F,F,F,F,F,F,F,F,F};
	
	public BlockStones(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, IIconContainer[] aIcons) {
		super(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier, aHardnessMultiplier, aHarvestLevel, 10, aIcons);
		if (aDefaultLocalised != null) {
			LH.add(getUnlocalizedName()+".0.name", aDefaultLocalised);
			LH.add(getUnlocalizedName()+".1.name", aDefaultLocalised+" Cobblestone");
			LH.add(getUnlocalizedName()+".2.name", "Mossy "+aDefaultLocalised+" Cobblestone");
			LH.add(getUnlocalizedName()+".3.name", aDefaultLocalised+" Bricks");
			LH.add(getUnlocalizedName()+".4.name", "Cracked "+aDefaultLocalised+" Bricks");
			LH.add(getUnlocalizedName()+".5.name", "Mossy "+aDefaultLocalised+" Bricks");
			LH.add(getUnlocalizedName()+".6.name", "Chiseled "+aDefaultLocalised);
			LH.add(getUnlocalizedName()+".7.name", "Smooth "+aDefaultLocalised);
			LH.add(getUnlocalizedName()+".8.name", "Reinforced "+aDefaultLocalised+" Bricks");
			LH.add(getUnlocalizedName()+".9.name", "Redstoned "+aDefaultLocalised+" Bricks");
		}
		if (aMaterial == null) {
			OM.data(ST.make(this, 1, 8), new OreDictItemData(MT.Stone, U, MT.Steel, OP.stick.mAmount));
			OM.data(ST.make(this, 1, 9), new OreDictItemData(MT.Stone, U, MT.Redstone, OP.dust.mAmount));
		} else {
			OM.data(ST.make(this, 1, 8), new OreDictItemData(aMaterial, U, MT.Steel, OP.stick.mAmount));
			OM.data(ST.make(this, 1, 9), new OreDictItemData(aMaterial, U, MT.Redstone, OP.dust.mAmount));
			OM.reg_(OP.stone, aMaterial, ST.make(this, 1, 0));
			OM.reg_(OP.stone, aMaterial, ST.make(this, 1, 1));
			OM.reg_(OP.stone, aMaterial, ST.make(this, 1, 2));
			OM.reg_(OP.stone, aMaterial, ST.make(this, 1, 3));
			OM.reg_(OP.stone, aMaterial, ST.make(this, 1, 4));
			OM.reg_(OP.stone, aMaterial, ST.make(this, 1, 5));
			OM.reg_(OP.stone, aMaterial, ST.make(this, 1, 6));
			OM.reg_(OP.stone, aMaterial, ST.make(this, 1, 7));
		}
		OP.crafting.addListener(this);
		RM.add_smelting(ST.make(this, 1, 0), ST.make(this, 1, 7));
		RM.add_smelting(ST.make(this, 1, 1), ST.make(this, 1, 0));
		RM.add_smelting(ST.make(this, 1, 2), ST.make(this, 1, 0));
		RM.add_smelting(ST.make(this, 1, 3), ST.make(this, 1, 0));
		RM.add_smelting(ST.make(this, 1, 4), ST.make(this, 1, 0));
		RM.add_smelting(ST.make(this, 1, 5), ST.make(this, 1, 0));
		RM.add_smelting(ST.make(this, 1, 6), ST.make(this, 1, 0));
		RM.add_smelting(ST.make(this, 1, 7), ST.make(this, 1, 0));
		
		UT.Crafting.shaped(ST.make(this, 1, 6), UT.Crafting.Bits.DEFAULT_NAC, new Object[] {"y" , "X" , 'X', ST.make(this, 1, 7)});
		UT.Crafting.shaped(ST.make(this, 1, 4), UT.Crafting.Bits.DEFAULT_NAC, new Object[] {"h" , "X" , 'X', ST.make(this, 1, 3)});
		UT.Crafting.shaped(ST.make(this, 1, 1), UT.Crafting.Bits.DEFAULT_NAC, new Object[] {"h" , "X" , 'X', ST.make(this, 1, 0)});
		UT.Crafting.shaped(ST.make(this, 4, 3), UT.Crafting.Bits.DEFAULT_NAC, new Object[] {"XX", "XX", 'X', ST.make(this, 4, 0)});
		UT.Crafting.shaped(ST.make(this, 4, 3), UT.Crafting.Bits.DEFAULT_NAC, new Object[] {"XX", "XX", 'X', ST.make(this, 4, 7)});
		UT.Crafting.shaped(ST.make(this, 1, 8), UT.Crafting.Bits.DEFAULT_NAC, new Object[] {"Se", "X ", 'X', ST.make(this, 1, 3), 'S', OP.stick.dat(MT.TECH.AnyIronSteel)});
		UT.Crafting.shaped(ST.make(this, 1, 9), UT.Crafting.Bits.DEFAULT_NAC, new Object[] {"Dh", "X ", 'X', ST.make(this, 1, 3), 'D', OP.dust.dat(MT.Redstone)});
		
		RM.Assembler	.addRecipe2(T, 16,					  16, ST.make(this, 1, 0), ST.tag(4), ST.make(this, 1, 3));
		RM.Hammer		.addRecipe1(T, 16,					  16, ST.make(this, 1, 0), ST.make(this, 1, 1));
		RM.Hammer		.addRecipe1(T, 16,					  16, ST.make(this, 1, 3), ST.make(this, 1, 4));
		RM.Crusher		.addRecipe1(T, 16,  25+aHarvestLevel* 25, ST.make(this, 1, 0), ST.make(this, 1, 1));
		RM.Crusher		.addRecipe1(T, 16,  50+aHarvestLevel* 50, ST.make(this, 1, 3), ST.make(this, 1, 4));
		RM.Crusher		.addRecipe1(T, 16,  50+aHarvestLevel* 50, ST.make(this, 1, 4), ST.make(this, 1, 1));
		RM.Crusher		.addRecipe1(T, 16,  50+aHarvestLevel* 50, ST.make(this, 1, 5), ST.make(this, 1, 1));
		RM.Crusher		.addRecipe1(T, 16,  50+aHarvestLevel* 50, ST.make(this, 1, 6), ST.make(this, 1, 1));
		RM.Crusher		.addRecipe1(T, 16,  50+aHarvestLevel* 50, ST.make(this, 1, 7), ST.make(this, 1, 1));
		RM.Crusher		.addRecipe1(T, 16, 200+aHarvestLevel*200, ST.make(this, 1, 8), ST.make(this, 1, 1), OM.dust(MT.Steel, OP.stick.mAmount));
		RM.Crusher		.addRecipe1(T, 16,  50+aHarvestLevel* 50, ST.make(this, 1, 9), ST.make(this, 1, 4), OM.dust(MT.Redstone));
	}
	
	@Override
	protected BlockMetaType makeSlab(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, int aCount, IIconContainer[] aIcons, byte aSlabType, BlockMetaType aBlock) {
		return new BlockStones(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier, aHardnessMultiplier, aHarvestLevel, aCount, aIcons, aSlabType, aBlock);
	}
	
	protected BlockStones(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, int aCount, IIconContainer[] aIcons, byte aSlabType, BlockMetaType aBlock) {
		super(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier, aHardnessMultiplier, aHarvestLevel, aCount, aIcons, aSlabType, aBlock);
		if (aDefaultLocalised != null) {
			LH.add(getUnlocalizedName()+".0.name", aDefaultLocalised+" Slab");
			LH.add(getUnlocalizedName()+".1.name", aDefaultLocalised+" Cobblestone Slab");
			LH.add(getUnlocalizedName()+".2.name", "Mossy "+aDefaultLocalised+" Cobblestone Slab");
			LH.add(getUnlocalizedName()+".3.name", aDefaultLocalised+" Bricks Slab");
			LH.add(getUnlocalizedName()+".4.name", "Cracked "+aDefaultLocalised+" Bricks Slab");
			LH.add(getUnlocalizedName()+".5.name", "Mossy "+aDefaultLocalised+" Bricks Slab");
			LH.add(getUnlocalizedName()+".6.name", "Chiseled "+aDefaultLocalised+" Slab");
			LH.add(getUnlocalizedName()+".7.name", "Smooth "+aDefaultLocalised+" Slab");
			LH.add(getUnlocalizedName()+".8.name", "Reinforced "+aDefaultLocalised+" Bricks Slab");
			LH.add(getUnlocalizedName()+".9.name", "Redstoned "+aDefaultLocalised+" Bricks Slab");
		}
		if (aMaterial == null) aMaterial = MT.Stone;
		OM.data(ST.make(this, 1, 0), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1, 1), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1, 2), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1, 3), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1, 4), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1, 5), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1, 6), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1, 7), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1, 8), new OreDictItemData(aMaterial, U2, MT.Steel, OP.stick.mAmount / 2));
		OM.data(ST.make(this, 1, 9), new OreDictItemData(aMaterial, U2, MT.Redstone, OP.dust.mAmount / 2));
		OM.data(ST.make(this, 1,10), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1,11), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1,12), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1,13), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1,14), new OreDictItemData(aMaterial, U2));
		OM.data(ST.make(this, 1,15), new OreDictItemData(aMaterial, U2));
	}
	
	@Override
	public void onOreRegistration(OreDictRegistrationContainer aEvent) {
		if (aEvent.mOreDictName.equals(DYE_OREDICTS_LENS[DYE_INDEX_White])) {
			RM.LaserEngraver.addRecipe2(T, 16, 64, ST.make(this, 1, 7), ST.amount(0, aEvent.mStack), ST.make(this, 1, 6));
		}
	}
	
	@Override
	public int getItemStackLimit(ItemStack aStack) {
		switch (ST.meta(aStack)) {
		case  1: return UT.Code.bindStack(OP.stoneCobble		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  2: return UT.Code.bindStack(OP.stoneMossy			.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  3: return UT.Code.bindStack(OP.stoneBricks		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  4: return UT.Code.bindStack(OP.stoneCracked		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  5: return UT.Code.bindStack(OP.stoneMossyBricks	.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  6: return UT.Code.bindStack(OP.stoneChiseled		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  7: return UT.Code.bindStack(OP.stonePolished		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  8: return UT.Code.bindStack(OP.stoneBricks		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  9: return UT.Code.bindStack(OP.stoneBricks		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		default: return UT.Code.bindStack(OP.stone				.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		}
	}
	
	@Override
	public long onToolClick(String aTool, long aRemainingDurability, long aQuality, Entity aPlayer, List<String> aChatReturn, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, World aWorld, byte aSide, int aX, int aY, int aZ, float aHitX, float aHitY, float aHitZ) {
		if (aTool.equals(TOOL_chisel)) {
			if (aWorld.getBlockMetadata(aX, aY, aZ) == 7) {
				aWorld.setBlockMetadataWithNotify(aX, aY, aZ, 6, 3);
				return mBlock == this ? 10000 : 5000;
			}
		}
		if (aTool.equals(TOOL_file)) {
			if (aWorld.getBlockMetadata(aX, aY, aZ) == 0) {
				aWorld.setBlockMetadataWithNotify(aX, aY, aZ, 7, 3);
				return mBlock == this ? 10000 : 5000;
			}
		}
		if (aTool.equals(TOOL_drill)) {
			if (mBlock == this && aPlayer instanceof EntityPlayer && aWorld.getBlockMetadata(aX, aY, aZ) == 3) {
				for (int i = 0; i < ((EntityPlayer)aPlayer).inventory.mainInventory.length; i++) {
					int tIndex = ((EntityPlayer)aPlayer).inventory.mainInventory.length-i-1;
					ItemStack tStack = ((EntityPlayer)aPlayer).inventory.mainInventory[tIndex];
					if (OM.is("stickAnyIronSteel", tStack)) {
						if (aWorld.setBlockMetadataWithNotify(aX, aY, aZ, 8, 3)) {
							if (!UT.Entities.hasInfiniteItems(aPlayer)) {
								if (--tStack.stackSize <= 0) {
									ForgeEventFactory.onPlayerDestroyItem(((EntityPlayer)aPlayer), tStack);
									((EntityPlayer)aPlayer).inventory.mainInventory[tIndex] = null;
								}
								if (((EntityPlayer)aPlayer).openContainer != null) ((EntityPlayer)aPlayer).openContainer.detectAndSendChanges();
							}
							return 10000;
						}
						break;
					}
				}
			}
		}
		return 0;
	}
	
	@Override
	public float getBlockHardness(World aWorld, int aX, int aY, int aZ) {
		switch(aWorld.getBlockMetadata(aX, aY, aZ)) {
		case  8: return Blocks.stone.getBlockHardness(aWorld, aX, aY, aZ) * mHardnessMultiplier * 2;
		default: return Blocks.stone.getBlockHardness(aWorld, aX, aY, aZ) * mHardnessMultiplier;
		}
	}
	
	@Override
	public float getExplosionResistance(int aMeta) {
		switch(aMeta) {
		case  8: return Blocks.stone.getExplosionResistance(null) * mResistanceMultiplier * 2;
		default: return Blocks.stone.getExplosionResistance(null) * mResistanceMultiplier;
		}
	}
	
    @Override
    public void updateTick(World aWorld, int aX, int aY, int aZ, Random aRandom) {
    	if (!aWorld.isRemote && UT.Worlds.getCoordsOnFire(aWorld, aX, aY, aZ)) switch(aWorld.getBlockMetadata(aX, aY, aZ)) {
    	case  2: aWorld.setBlock(aX, aY, aZ, this, 1, 3); break;
    	case  5: aWorld.setBlock(aX, aY, aZ, this, 3, 3); break;
    	}
    }
    
    @Override public int isProvidingWeakPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {return aWorld.getBlockMetadata(aX, aY, aZ) == 9 ? 15 : 0;}
	@Override public boolean shouldCheckWeakPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {return aWorld.getBlockMetadata(aX, aY, aZ) != 9;}
	@Override public void onNeighborBlockChange(World aWorld, int aX, int aY, int aZ, Block aBlock) {if (MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))] && UT.Worlds.getCoordsOnFire(aWorld, aX, aY, aZ)) aWorld.scheduleBlockUpdate(aX, aY, aZ, this, tickRate(aWorld));}
    @Override public void onBlockAdded(World aWorld, int aX, int aY, int aZ) {if (MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))] && UT.Worlds.getCoordsOnFire(aWorld, aX, aY, aZ)) aWorld.scheduleBlockUpdate(aX, aY, aZ, this, tickRate(aWorld));}
	@Override public int tickRate(World aWorld) {return 100;}
	@Override public int damageDropped(int aMeta) {return aMeta==0?1:aMeta;}
	@Override public boolean canCreatureSpawn(int aMeta) {return mBlock == this && aMeta < 3;}
	@Override public int getFlammability(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {return 0;}
	@Override public boolean isFlammable(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {return MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))];}
	@Override public int getFireSpreadSpeed(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {return MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))]?3000:0;}
	@Override public boolean isFireSource(World aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {return MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))];}
	@Override public boolean isReplaceableOreGen(World aWorld, int aX, int aY, int aZ, Block aTarget) {return aWorld.getBlockMetadata(aX, aY, aZ) == 0 && (aTarget == this || aTarget == Blocks.stone);}
}